{
  Autor       : Michael Springwald
  Erstellt am : Sonntag, 05.Juli.2009
  Änderungen
    -----------------------------------------------------------------------------------
  01| Montag.Jul.09                     | Dienstag.Jul.09                             |
    -----------------------------------------------------------------------------------
  02| Donnerstag.Jul.09                 | Freitag.Jul.09                              |
    -----------------------------------------------------------------------------------
  03| Samstag.Jul.09                    |                                             |
    -----------------------------------------------------------------------------------
  04|                                   |                                             |
    -----------------------------------------------------------------------------------
  05|                                   |                                             |
    -----------------------------------------------------------------------------------
  Options_List_Verti
  - NoSetAutoIndexByZeroAndItemsEnd
  - Report
  -

  Options_List_Hori
  - NoSetAutoIndexByZeroAndItemsEnd
  - AlignmentCompackt
  - MultiLine

}

unit uPL_LV;

{$mode objfpc}{$H+}

interface

uses

  Classes, SysUtils, Controls, Graphics,
  contnrs, LCLType, LCLIntf, LCLProc, LMessages, Messages,
  uPL_IT
  ;

type
  { TPL_LV }
  TPL_LV = class(TCustomControl)
  private
    fItems: TPL_ITL;
    SV,SH: TScrollInfo;
    procedure SetItems(const AValue: TPL_ITL);
  protected

  public
    ScrollWidth,ScrollHeight:Integer;
    NewPaint:Boolean;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    procedure ScrollV(const aScrollCode, aPos:Integer);
    procedure ScrollH(const aScrollCode, aPos:Integer);
    procedure WMVScroll(var Message: TWMVScroll); message WM_VSCROLL;
    procedure WMHScroll(var Message: TWMHScroll); message WM_HSCROLL;

    procedure SetupScroll(const aVerti:Boolean);
    procedure SetupScrollBars;

    procedure WMEraseBkgnd(var Message: TLMEraseBkgnd); message
                   LM_ERASEBKGND;
    procedure EraseBackground(DC: HDC); override;
    procedure Resize; override;

    procedure Paint; override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X,
              Y: Integer); override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;

    procedure ItemsChange(const aMod:TPL_ITL_ChangeMod);
    procedure Scroll(const aScroll: Integer; const aScrollDir:Boolean);
    property Items:TPL_ITL read fItems write SetItems;
  published

  end; // TPL_LV

implementation

{ TPL_LV }

procedure TPL_LV.SetItems(const AValue: TPL_ITL);
begin
  fItems:=AValue;
  writeln('OK,OK,OK,OK');
end; // TPL_LV.SetItems

constructor TPL_LV.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ITems:=TPL_ITL.Create(Canvas);
  Items.onChange:=@ItemsChange;
  ScrollHeight:=-1; NewPaint:=False; ScrollWidth:=-1;
  items.onScroll:=@Scroll;

end; // TPL_LV.Create

destructor TPL_LV.Destroy;
begin
  inherited Destroy;
end; // TPL_LV.Destroy

procedure TPL_LV.ScrollV(const aScrollCode, aPos: Integer);
begin
  inherited;
  with Items do begin
    Case aScrollCode of
      SB_TOP: ScrollRect.Top:=0;
      SB_BOTTOM: ScrollRect.Top:=ScrollHeight-ClientHeight;
      SB_LINEUP: begin
        if ScrollRect.Top-DefaultItemHeight-5 >=0 then
          ScrollRect.Top:=ScrollRect.Top-DefaultItemHeight-5
        else
          ScrollRect.Top:=0;
      end; // SB_LINEUP
      SB_LINEDOWN: begin
        if ScrollRect.Top+DefaultItemHeight+5 <=ScrollHeight-ScrollRect.Bottom then
          ScrollRect.Top:=ScrollRect.Top+DefaultItemHeight+5
        else
          ScrollRect.Top:=ScrollHeight-ScrollRect.Bottom;
      end; // SB_LINEDOWN
      SB_PAGEUP: begin
        if ScrollRect.Top-ScrollRect.Bottom >=0 then
          ScrollRect.Top:=ScrollRect.Top-ScrollRect.Bottom
        else
          ScrollRect.Top:=0;
      end; // SB_PAGEUP
      SB_PAGEDOWN: begin
        if ScrollRect.Top+ScrollRect.Bottom <=ScrollHeight-ScrollRect.Bottom then
          ScrollRect.Top:=ScrollRect.Top+ScrollRect.Bottom
        else
          ScrollRect.Top:=ScrollHeight-ScrollRect.Bottom;
      end; // SB_PAGEDOWN
      SB_THUMBTRACK,SB_THUMBPOSITION: begin
        if apos+ScrollRect.Bottom <=ScrollHeight then
          ScrollRect.Top:=aPos
        else
          ScrollRect.Top:=ScrollHeight-ScrollRect.Bottom;
      end; // SB_THUMBTRACK,SB_THUMBPOSITION
    end; // Of Case
    SetupScrollBars;
    if not NewPaint then
      Invalidate
    else
      NewPaint:=False;
  end; // with Items
end; // TPL_LV.ScrollV

procedure TPL_LV.ScrollH(const aScrollCode, aPos: Integer);
begin
  inherited;
  with Items do begin
    Case aScrollCode of
      SB_LEFT: begin
        ScrollRect.Left:=0;
      end; // SB_LEFT

      SB_RIGHT: begin
        ScrollRect.Left:=ScrollWidth-ScrollRect.Right;
      end; // SB_RIGHT

      SB_LINERIGHT: begin
        if ScrollRect.Left+108+5 <=ScrollWidth-ScrollRect.Right then
          ScrollRect.Left:=ScrollRect.Left+108+5
        else
          ScrollRect.Left:=ScrollWidth-ScrollRect.Right;
      end; // SB_LINERIGHT
      SB_LINELEFT: begin
        if ScrollRect.Left-108-5 >=0 then
          ScrollRect.Left:=ScrollRect.Left-108-5
        else
          ScrollRect.Left:=0;
      end; // SB_LINELEFT
      SB_THUMBTRACK,SB_THUMBPOSITION: begin
        if apos+ScrollRect.Right <=ScrollWidth then
          ScrollRect.Left:=aPos
        else
          ScrollRect.Left:=ScrollWidth-ScrollRect.Right;
      end; // SB_THUMBTRACK
    end; // case

    SetupScrollBars;
//    if not NewPaint then
      Invalidate
  //  else
    //  NewPaint:=False;
  end; // with
end; // TPL_LV.ScrollH

procedure TPL_LV.WMVScroll(var Message: TWMVScroll);
begin
  inherited;
  ScrollV(Message.ScrollCode,Message.Pos);
end; // TPL_LV.WMVScroll

procedure TPL_LV.WMHScroll(var Message: TWMHScroll);
begin
  inherited;
  ScrollH(Message.ScrollCode,Message.Pos);
end; // TPL_LV.WMHScroll

procedure TPL_LV.SetupScroll(const aVerti: Boolean);
begin

end; // TPL_LV.SetupScroll

procedure TPL_LV.SetupScrollBars;
begin
  if (HandleAllocated) and (ClientHeight > 0) and (ClientWidth > 0) and (items.Count > 0) then begin
    ScrollHeight:=Items[items.Count-1].ItemRect.Bottom;
    ScrollWidth:=Items[items.Count-1].ItemRect.Left;
    items.ViewLastIndex:=-1; items.ViewFirstIndex:=-1;
    if (items.Alignment = ag_Hori) or (items.Alignment = ag_Verti) then begin
      SV.cbSize := SizeOf(SV);
      SV.fMask :=SIF_POS or SIF_RANGE or SIF_PAGE or SIF_DISABLENOSCROLL ;
      SV.nPos :=Items.ScrollRect.Top;
      SV.nMin := 0;
      SV.nMax :=ScrollHeight;
      SV.nPage:=ClientHeight;
      SetScrollInfo(Handle, SB_Vert, SV,True);
    end
    else begin
      // TODO: Scrollbalken wieder ausschalten
      items.ScrollRect.Top:=0;
      SV.cbSize := SizeOf(SV);
      SV.fMask :=SIF_POS or SIF_RANGE or SIF_PAGE or SIF_DISABLENOSCROLL ;
      SV.nPos :=0;
      SV.nMin := 0;
      SV.nMax :=ScrollHeight;
      SV.nPage:=ClientHeight;
      SetScrollInfo(Handle, SB_Vert, SV,True);
    end;

    if (items.Alignment = AG_OneLine) then begin
      SH.cbSize := SizeOf(SH);
      SH.fMask := SIF_POS or SIF_RANGE or SIF_PAGE or SIF_DISABLENOSCROLL;
      SH.nPos := Items.ScrollRect.Left;
      SH.nMin := 0;
      SH.nMax :=ScrollWidth;
      SH.nPage:= ClientWidth;
      SetScrollInfo(Handle, SB_Horz, SH, true);
    end
    else begin
      // TODO: Scrollbalken wieder ausschalten
      Items.ScrollRect.Left:=0;
      SH.cbSize := SizeOf(SH);
      SH.fMask := SIF_POS or SIF_RANGE or SIF_PAGE or SIF_DISABLENOSCROLL;
      SH.nPos := Items.ScrollRect.Left;
      SH.nMin := 0;
      SH.nMax :=ScrollWidth;
      SH.nPage:= ClientWidth;
      SetScrollInfo(Handle, SB_Horz, SH, True);
    end;
  end;
end; // TPL_LV.SetupScrollBars

procedure TPL_LV.WMEraseBkgnd(var Message: TLMEraseBkgnd);
begin

end; // TPL_LV.WMEraseBkgnd

procedure TPL_LV.EraseBackground(DC: HDC);
begin
//  inherited EraseBackground(DC);
end; // TPL_LV.EraseBackground

procedure TPL_LV.Resize;
begin
  items.Init:=False;
  items.ScrollRect.Right:=ClientWidth;
  items.ScrollRect.Bottom:=ClientHeight;
  items.InitItems;
  ScrollHeight:=-1;
  SetupScrollBars;
end; // TPL_LV.Resize

procedure TPL_LV.Paint;
var
  i, px, py,py1,z,m,mc:Integer;
  ok1,ok2:Boolean;
begin
  inherited Paint;
  Canvas.Brush.Color:=clWhite;
  Canvas.Brush.Style:=bsSolid;
  Canvas.Font.Color:=clBlue; Canvas.Font.Name:='Monospace';
  Canvas.Font.Size:=12; Canvas.Font.Style:=[];
  Canvas.FillRect(0, 0, Width, Height);
  px:=2; py:=5; z:=1; py1:=0;
  ok1:=False; ok2:=False;
  if items.Count > 0 then begin
    if (Items.ViewFirstIndex > -1) and (Items.ViewLastIndex > -1) then begin
      m:=Items.ViewFirstIndex; mc:=items.ViewLastIndex;
    end
    else begin
      m:=0; mc:=Items.Count-1;
    end;
//    writeln(items.ViewFirstIndex);
    for i:=m to mc do begin
      py1:=py; items[i].Index:=i; items[i].ItemX:=z;
      items[i].Paint(px,py);
      if (items.ViewFirstIndex = -1) then begin
        if (items.Alignment = ag_Verti) or (items.Alignment = ag_Hori) then
          ok1:=(py+Items[i].ItemHeigh >=Items.ScrollRect.Top);

        if Items.Alignment = AG_OneLine then
          ok1:=(px+Items[i].ItemWidth >=Items.ScrollRect.Left);

        if ok1 then begin
  //        writeln('ViewFirstIndex:'+items[i].text);
          items.ViewFirstIndex:=i;
        end;
      end;

      if ((items.ViewLastIndex = -1) {and (px > px1)}) or (i = items.Count-1) then begin
        if (items.Alignment = ag_Verti) or (items.Alignment = ag_Hori) then
          ok2:=((py-Items.ScrollRect.Top)+items[i].ItemHeigh >=ClientHeight+items[i].ItemHeigh) or (i = items.Count-1);

        if items.Alignment = AG_OneLine then begin
          ok2:=((px-Items.ScrollRect.Left) >=ClientWidth-Items[i].ItemWidth) or (i = items.Count-1);
        end;

        if ok2 then begin
          if items.ViewLastIndex = -1 then begin
  //          writeln('ViewLastIndex:'+items[i].text);
            items.ViewLastIndex:=i;
            break;
          end;
        end;
      end;
      if py >= py1 then begin
        z:=0;
      end
      else
        inc(z);
      if (not Items.Init) and (i >= Items.Count-1) then items.init:=True;
    end; // for i
//    writeln('LineCount:',items.LineCount);
  end;
end; // TPL_LV.Paint

procedure TPL_LV.MouseDown(Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
var
  item:Integer;
begin
  inherited MouseDown(Button, Shift, X, Y);
  item:=items.GetItemIndexBYXY(x,y);
//  if item > -1 then
///    writeln(items[item].ItemRect.Left);
{  if item > -1 then
    writeln('item.Text:',items[item].Text)
  else
    writeln('Kein Eintrag ausgewählt !!!');}
  items.ItemIndex:=item;
end; // TPL_LV.MouseDown

procedure TPL_LV.KeyDown(var Key: Word; Shift: TShiftState);
var
  i,sx:Integer;
begin
//  inherited KeyDown(Key, Shift);
  case key of
    VK_HOME:begin
      Items.ItemIndex:=0;
      ScrollV(SB_TOP,0);
      Invalidate;
    end; // VK_Home
    VK_END: begin
      Items.ItemIndex:=Items.Count-1;
      ScrollV(SB_BOTTOM,Items.Count-1);
      Invalidate;
    end; // VK_END
    VK_PRIOR: begin
{      Items.ItemIndex:=Items.Count-1;
      ScrollV(SB_PAGEUP,Items.Count-1);
      Invalidate;}
    end; // VK_PRIOR
    VK_NEXT: begin
{      Items.ItemIndex:=Items.Count-1;
      ScrollV(SB_PAGEDOWN,Items.Count-1);
      Invalidate;}
    end; // VK_NEXT
  end; // case

  case items.Alignment of
    ag_Hori: items.Key_Move_ag_Hori(key,Shift);
    ag_Verti: items.Key_Move_agVertikal(key,Shift);
    AG_OneLine: items.Key_Move_agOneLine(key,Shift);
  end; // case
end; // TPL_LV.KeyDown

procedure TPL_LV.ItemsChange(const aMod: TPL_ITL_ChangeMod);
begin
  if not (aMod = LC_Alignment) then begin
    if Assigned(Parent) then Paint;
  end
  else begin
    Items.InitItems;
    SetupScrollBars;
    Invalidate;
  end;
end; // TPL_LV.ItemsChange

procedure TPL_LV.Scroll(const aScroll: Integer; const aScrollDir:Boolean);
begin
  if aScrollDir then
    ScrollH(aScroll,-1)
  else
    ScrollV(aScroll,-1)
end; // TPL_LV.Scroll

//  {$I uPL_IT.inc}
end.

